/* ------------------------------------------------------------------ */
/*      item            : ActivityDescription.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : ActivityDescription.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Activity object description for logging purposes
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2

*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ActivityDescription.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <stringoptions.h>
#include <GlobalId.hxx>

namespace dueca {
 
/** Objects of this class describe an activity. These are mainly used
    to communicate data for the activity visualisation
    */
struct ActivityDescription
{
  /** typedef for internal reference */
  typedef ActivityDescription __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** Name of the activity, limited to 31 characters */
  string32 name;

  /** Owner, indicated by its id */
  GlobalId owner;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ActivityDescription();

  /** Constructor with arguments */
  ActivityDescription(
        const string32& name,
        const GlobalId& owner);

  /** copy constructor. */
  ActivityDescription(const ActivityDescription& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ActivityDescription from amorphous storage. */
  ActivityDescription(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ActivityDescription();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ActivityDescription*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ActivityDescription into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ActivityDescription into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ActivityDescription& ref) const;

  /** unpacks the ActivityDescription from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ActivityDescription
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ActivityDescription& o) const;

  /** Test for inequality. */
  inline bool operator != (const ActivityDescription& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ActivityDescription& operator=(const ActivityDescription& o);

  /** prints the ActivityDescription to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ActivityDescription& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ActivityDescription& o,
                         const dueca::ActivityDescription& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ActivityDescription& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ActivityDescription& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ActivityDescription& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ActivityDescription>();
template <>
inline const char* dueca::getclassname<const dueca::ActivityDescription>()
{ return dueca::getclassname<dueca::ActivityDescription>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ActivityDescription is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ActivityDescription> : public dco_isnested { };
};

#endif


