/* ------------------------------------------------------------------ */
/*      item            : ChannelChangeNotification.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : ChannelChangeNotification.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Generated from a hard-coded version
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ChannelChangeNotification.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <NameSet.hxx>
#include <GlobalId.hxx>

namespace dueca {
 
/** Event data for updating channel registries
    */
struct ChannelChangeNotification
{
  /** typedef for internal reference */
  typedef ChannelChangeNotification __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


/** different notification types
 */
  enum NotificationType {
    /** A new end has been created */
    NewChannelEnd,
    /** End has been removed */
    RemoveEnd,
    /** End is writing end */
    IsWritingEnd
  };

  /** The type of message this is */
  NotificationType notification_type;

  /** Defining name of the channel */
  NameSet name_set;

  /** ID (if it has been issued) of the channel end */
  GlobalId global_id;

  /** Code for the transport class, to coordinate transport prio */
  uint8_t transportclass;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ChannelChangeNotification(
        const GlobalId& global_id = GlobalId());

  /** Constructor with arguments */
  ChannelChangeNotification(
        const NotificationType& notification_type,
        const NameSet& name_set,
        const GlobalId& global_id,
        const uint8_t& transportclass);

  /** copy constructor. */
  ChannelChangeNotification(const ChannelChangeNotification& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ChannelChangeNotification from amorphous storage. */
  ChannelChangeNotification(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ChannelChangeNotification();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ChannelChangeNotification*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ChannelChangeNotification into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ChannelChangeNotification into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ChannelChangeNotification& ref) const;

  /** unpacks the ChannelChangeNotification from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ChannelChangeNotification
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ChannelChangeNotification& o) const;

  /** Test for inequality. */
  inline bool operator != (const ChannelChangeNotification& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ChannelChangeNotification& operator=(const ChannelChangeNotification& o);

  /** prints the ChannelChangeNotification to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "ChannelChangeNotificationExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ChannelChangeNotification& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ChannelChangeNotification& o,
                         const dueca::ChannelChangeNotification& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ChannelChangeNotification& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ChannelChangeNotification& o)
{ o.unPackDataDiff(s); }
#endif

namespace dueca {
  const char* const getString(const dueca::ChannelChangeNotification::NotificationType &o);
  void readFromString(dueca::ChannelChangeNotification::NotificationType &o, const std::string& s);
  void getFirst(dueca::ChannelChangeNotification::NotificationType &o);
  bool getNext(dueca::ChannelChangeNotification::NotificationType &o);

  /** This function retrieves the classname of an ChannelChangeNotification::NotificationType */
  template <>
  const char* getclassname<dueca::ChannelChangeNotification::NotificationType>();
}; // end namespace dueca

#if !defined(__DCO_NOPACK)
void packData(::dueca::AmorphStore& s,
              const dueca::ChannelChangeNotification::NotificationType &o);
void unPackData(::dueca::AmorphReStore& s,
                dueca::ChannelChangeNotification::NotificationType &o);
#endif

PRINT_NS_START;
/** Print an object of type ChannelChangeNotification::NotificationType */
inline std::ostream&
operator << (std::ostream& s, const dueca::ChannelChangeNotification::NotificationType& o)
{ return s << dueca::getString(o); }
/** Read an object of type ChannelChangeNotification::NotificationType */
inline std::istream&
/** Read an enum of type ChannelChangeNotification::NotificationType */
operator >> (std::istream& s, dueca::ChannelChangeNotification::NotificationType& o)
{ std::string tmp; s >> tmp; dueca::readFromString(o, tmp); return s; }
PRINT_NS_END;

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ChannelChangeNotification& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ChannelChangeNotification>();
template <>
inline const char* dueca::getclassname<const dueca::ChannelChangeNotification>()
{ return dueca::getclassname<dueca::ChannelChangeNotification>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ChannelChangeNotification is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ChannelChangeNotification> : public dco_isnested { };
template <>
struct dco_nested<dueca::ChannelChangeNotification::NotificationType> : public dco_isenum { };
};

#endif


