/* ------------------------------------------------------------------ */
/*      item            : ChannelCountResult.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : ChannelCountResult.dco
        made by         : Rene' van Paassen
        date            : 180509
        description     : Return a count of channel entry writes/reads
        copyright       : (c) 2018-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ChannelCountResult.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include "GlobalId.hxx"
#include <inttypes.h>
#include <EntryCountResult.hxx>
#include <varvector.hxx>
typedef dueca::varvector<dueca::EntryCountResult> entries_list;

namespace dueca {
 
/** Useful information about channel readers
    */
struct ChannelCountResult
{
  /** typedef for internal reference */
  typedef ChannelCountResult __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** channel number */
  GlobalId channelid;

  /** creation id */
  uint32_t countid;

  /** A class member */
  entries_list entries;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ChannelCountResult();

  /** Constructor with arguments */
  ChannelCountResult(
        const GlobalId& channelid,
        const uint32_t& countid,
        const entries_list& entries);

  /** Constructor with all single (non-iterable) arguments */
  ChannelCountResult(
        const GlobalId& channelid,
        const uint32_t& countid);

  /** copy constructor. */
  ChannelCountResult(const ChannelCountResult& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ChannelCountResult from amorphous storage. */
  ChannelCountResult(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ChannelCountResult();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ChannelCountResult*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ChannelCountResult into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ChannelCountResult into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ChannelCountResult& ref) const;

  /** unpacks the ChannelCountResult from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ChannelCountResult
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ChannelCountResult& o) const;

  /** Test for inequality. */
  inline bool operator != (const ChannelCountResult& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ChannelCountResult& operator=(const ChannelCountResult& o);

  /** prints the ChannelCountResult to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ChannelCountResult& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ChannelCountResult& o,
                         const dueca::ChannelCountResult& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ChannelCountResult& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ChannelCountResult& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ChannelCountResult& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ChannelCountResult>();
template <>
inline const char* dueca::getclassname<const dueca::ChannelCountResult>()
{ return dueca::getclassname<dueca::ChannelCountResult>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ChannelCountResult is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ChannelCountResult> : public dco_isnested { };
};

#endif


