/* ------------------------------------------------------------------ */
/*      item            : ChannelReadInfo.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : ChannelReadInfo.dco
        made by         : Rene' van Paassen
        date            : 180301
        description     : Additional information on channel use
        copyright       : (c) 2018-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ChannelReadInfo.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <dueca/GlobalId.hxx>
#include <inttypes.h>
#include <dueca/ChannelDef.hxx>

namespace dueca {
 
/** Useful information about channel readers
    */
struct ChannelReadInfo
{
  /** typedef for internal reference */
  typedef ChannelReadInfo __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


/** Different types of information message
 */
  enum InfoType {
    /** Attaching to a numbered entry */
    byId,
    /** Attaching to a labeled entry */
    byLabel,
    /** Multiple attachement, to all matching classes */
    Multiple,
    /** Remove again, entry deleted */
    Deleted,
    /** Reader removes token */
    Detached
  };

  /** channel id */
  GlobalId channelid;

  /** client id */
  GlobalId clientid;

  /** creation id */
  uint32_t creationid;

  /** entry number */
  entryid_type entryid;

  /** reading all or just time-selected */
  bool sequential;

  /** type of notification */
  InfoType action;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ChannelReadInfo();

  /** Constructor with arguments */
  ChannelReadInfo(
        const GlobalId& channelid,
        const GlobalId& clientid,
        const uint32_t& creationid,
        const entryid_type& entryid,
        const bool& sequential,
        const InfoType& action);

  /** copy constructor. */
  ChannelReadInfo(const ChannelReadInfo& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ChannelReadInfo from amorphous storage. */
  ChannelReadInfo(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ChannelReadInfo();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ChannelReadInfo*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ChannelReadInfo into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ChannelReadInfo into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ChannelReadInfo& ref) const;

  /** unpacks the ChannelReadInfo from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ChannelReadInfo
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ChannelReadInfo& o) const;

  /** Test for inequality. */
  inline bool operator != (const ChannelReadInfo& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ChannelReadInfo& operator=(const ChannelReadInfo& o);

  /** prints the ChannelReadInfo to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "ChannelReadInfoExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ChannelReadInfo& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ChannelReadInfo& o,
                         const dueca::ChannelReadInfo& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ChannelReadInfo& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ChannelReadInfo& o)
{ o.unPackDataDiff(s); }
#endif

namespace dueca {
  const char* const getString(const dueca::ChannelReadInfo::InfoType &o);
  void readFromString(dueca::ChannelReadInfo::InfoType &o, const std::string& s);
  void getFirst(dueca::ChannelReadInfo::InfoType &o);
  bool getNext(dueca::ChannelReadInfo::InfoType &o);

  /** This function retrieves the classname of an ChannelReadInfo::InfoType */
  template <>
  const char* getclassname<dueca::ChannelReadInfo::InfoType>();
}; // end namespace dueca

#if !defined(__DCO_NOPACK)
void packData(::dueca::AmorphStore& s,
              const dueca::ChannelReadInfo::InfoType &o);
void unPackData(::dueca::AmorphReStore& s,
                dueca::ChannelReadInfo::InfoType &o);
#endif

PRINT_NS_START;
/** Print an object of type ChannelReadInfo::InfoType */
inline std::ostream&
operator << (std::ostream& s, const dueca::ChannelReadInfo::InfoType& o)
{ return s << dueca::getString(o); }
/** Read an object of type ChannelReadInfo::InfoType */
inline std::istream&
/** Read an enum of type ChannelReadInfo::InfoType */
operator >> (std::istream& s, dueca::ChannelReadInfo::InfoType& o)
{ std::string tmp; s >> tmp; dueca::readFromString(o, tmp); return s; }
PRINT_NS_END;

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ChannelReadInfo& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ChannelReadInfo>();
template <>
inline const char* dueca::getclassname<const dueca::ChannelReadInfo>()
{ return dueca::getclassname<dueca::ChannelReadInfo>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ChannelReadInfo is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ChannelReadInfo> : public dco_isnested { };
template <>
struct dco_nested<dueca::ChannelReadInfo::InfoType> : public dco_isenum { };
};

#endif


