/* ------------------------------------------------------------------ */
/*      item            : ChannelWriteInfo.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : ChannelWriteInfo.dco
        made by         : Rene' van Paassen
        date            : 180329
        description     : Additional information on channel use
        copyright       : (c) 2018-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ChannelWriteInfo.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <dueca/GlobalId.hxx>
#include <dueca/ChannelDef.hxx>
#include <string>

namespace dueca {
 
/** Useful information about channel writers
    */
struct ChannelWriteInfo
{
  /** typedef for internal reference */
  typedef ChannelWriteInfo __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** channel id */
  GlobalId channelid;

  /** client id, if undefined, signals removal of entry */
  GlobalId clientid;

  /** entry number */
  entryid_type entryid;

  /** data class written */
  std::string dataclass;

  /** label of the entry */
  std::string label;

  /** timing nature, event or stream */
  bool eventtype;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ChannelWriteInfo();

  /** Constructor with arguments */
  ChannelWriteInfo(
        const GlobalId& channelid,
        const GlobalId& clientid,
        const entryid_type& entryid,
        const std::string& dataclass,
        const std::string& label,
        const bool& eventtype);

  /** copy constructor. */
  ChannelWriteInfo(const ChannelWriteInfo& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ChannelWriteInfo from amorphous storage. */
  ChannelWriteInfo(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ChannelWriteInfo();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ChannelWriteInfo*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ChannelWriteInfo into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ChannelWriteInfo into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ChannelWriteInfo& ref) const;

  /** unpacks the ChannelWriteInfo from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ChannelWriteInfo
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ChannelWriteInfo& o) const;

  /** Test for inequality. */
  inline bool operator != (const ChannelWriteInfo& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ChannelWriteInfo& operator=(const ChannelWriteInfo& o);

  /** prints the ChannelWriteInfo to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "ChannelWriteInfoExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ChannelWriteInfo& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ChannelWriteInfo& o,
                         const dueca::ChannelWriteInfo& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ChannelWriteInfo& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ChannelWriteInfo& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ChannelWriteInfo& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ChannelWriteInfo>();
template <>
inline const char* dueca::getclassname<const dueca::ChannelWriteInfo>()
{ return dueca::getclassname<dueca::ChannelWriteInfo>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ChannelWriteInfo is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ChannelWriteInfo> : public dco_isnested { };
};

#endif


