/* ------------------------------------------------------------------   */
/*      item            : DCOTypeIndex.hxx
        made by         : Rene van Paassen
        date            : 181107
        category        : header file
        description     :
        changes         : 181107 first version
        language        : C++
        copyright       : (c) 2018 TUDelft-AE-C&S
        copyright       : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#ifndef DCOTypeIndex_hxx
#define DCOTypeIndex_hxx

/** use STD typeindex */
#define USE_STD_TYPEINDEX

#include <dueca_ns.h>

#ifdef USE_STD_TYPEINDEX
#include <typeindex>
#include <typeinfo>
DUECA_NS_START;
typedef std::type_index typeindex_t;
DUECA_NS_END;
#define TYPEID(A) typeid(A)
#else
#include <boost/type_index.hpp>
DUECA_NS_START;
typedef boost::typeindex::type_index typeindex_t;
DUECA_NS_END;
#define TYPEID(A) boost::typeindex::type_id< A >()
#endif


#endif
