/* ------------------------------------------------------------------ */
/*      item            : EntityUpdate.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : EntityUpdate.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Control entity state machine
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated EntityUpdate.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <NameSet.hxx>
#include <GlobalId.hxx>
#include <ModuleState.hxx>

namespace dueca {
 
/** Controls the starting, stopping etcetera of modules
    */
struct EntityUpdate
{
  /** typedef for internal reference */
  typedef EntityUpdate __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


/** Enumeration type for communication between the EntityManagers
 */
  enum EntityUpdateType {
    /** The entity has been created */
    Created,
    /** Provide a report on the current status */
    Report,
    /** Implement the desired state */
    Command,
    /** Get status from a specific entity */
    Query
  };

  /** name of the affected module */
  NameSet name_set;

  /** id of the same module */
  GlobalId global_id;

  /** type of communication in this command */
  EntityUpdateType t;

  /** state of the relevant module */
  ModuleState state;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  EntityUpdate();

  /** Constructor with arguments */
  EntityUpdate(
        const NameSet& name_set,
        const GlobalId& global_id,
        const EntityUpdateType& t,
        const ModuleState& state);

  /** copy constructor. */
  EntityUpdate(const EntityUpdate& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an EntityUpdate from amorphous storage. */
  EntityUpdate(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~EntityUpdate();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, EntityUpdate*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the EntityUpdate into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the EntityUpdate into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const EntityUpdate& ref) const;

  /** unpacks the EntityUpdate from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for EntityUpdate
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const EntityUpdate& o) const;

  /** Test for inequality. */
  inline bool operator != (const EntityUpdate& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  EntityUpdate& operator=(const EntityUpdate& o);

  /** prints the EntityUpdate to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::EntityUpdate& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::EntityUpdate& o,
                         const dueca::EntityUpdate& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::EntityUpdate& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::EntityUpdate& o)
{ o.unPackDataDiff(s); }
#endif

namespace dueca {
  const char* const getString(const dueca::EntityUpdate::EntityUpdateType &o);
  void readFromString(dueca::EntityUpdate::EntityUpdateType &o, const std::string& s);
  void getFirst(dueca::EntityUpdate::EntityUpdateType &o);
  bool getNext(dueca::EntityUpdate::EntityUpdateType &o);

  /** This function retrieves the classname of an EntityUpdate::EntityUpdateType */
  template <>
  const char* getclassname<dueca::EntityUpdate::EntityUpdateType>();
}; // end namespace dueca

#if !defined(__DCO_NOPACK)
void packData(::dueca::AmorphStore& s,
              const dueca::EntityUpdate::EntityUpdateType &o);
void unPackData(::dueca::AmorphReStore& s,
                dueca::EntityUpdate::EntityUpdateType &o);
#endif

PRINT_NS_START;
/** Print an object of type EntityUpdate::EntityUpdateType */
inline std::ostream&
operator << (std::ostream& s, const dueca::EntityUpdate::EntityUpdateType& o)
{ return s << dueca::getString(o); }
/** Read an object of type EntityUpdate::EntityUpdateType */
inline std::istream&
/** Read an enum of type EntityUpdate::EntityUpdateType */
operator >> (std::istream& s, dueca::EntityUpdate::EntityUpdateType& o)
{ std::string tmp; s >> tmp; dueca::readFromString(o, tmp); return s; }
PRINT_NS_END;

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::EntityUpdate& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::EntityUpdate>();
template <>
inline const char* dueca::getclassname<const dueca::EntityUpdate>()
{ return dueca::getclassname<dueca::EntityUpdate>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    EntityUpdate is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::EntityUpdate> : public dco_isnested { };
template <>
struct dco_nested<dueca::EntityUpdate::EntityUpdateType> : public dco_isenum { };
};

#endif


