/* ------------------------------------------------------------------ */
/*      item            : GlobalId.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : GlobalId.dco
        made by         : Rene' van Paassen
        date            : 1301002
        documentation   : DUECA_API
        description     : ID for channels or objects
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated GlobalId.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <inttypes.h>
typedef uint8_t LocationId;
typedef uint16_t ObjectId;

namespace dueca {
 
/** This class defines an ID pair, consisting of a location id, identifying
    a participating dueca node, and an object id, identifying an
    object (or channel) created in that node.
   
    The ObjectManager maintains a list of references to local objects, indexed
    on the object id, the ChannelManager does the same for channels.
   
    Local and remote queries for an object, defined by its name
    and the entity in which it participates, are returned with a GlobalId
    */
struct GlobalId
{
  /** typedef for internal reference */
  typedef GlobalId __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** ID part pointing to the dueca node */
  LocationId location;

  /** Unique ID within the dueca node */
  ObjectId object;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  GlobalId();

  /** Constructor with arguments */
  GlobalId(
        const LocationId& location,
        const ObjectId& object);

  /** copy constructor. */
  GlobalId(const GlobalId& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an GlobalId from amorphous storage. */
  GlobalId(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~GlobalId();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, GlobalId*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the GlobalId into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the GlobalId into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const GlobalId& ref) const;

  /** unpacks the GlobalId from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for GlobalId
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const GlobalId& o) const;

  /** Test for inequality. */
  inline bool operator != (const GlobalId& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  GlobalId& operator=(const GlobalId& o);

  /** prints the GlobalId to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "GlobalIdExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::GlobalId& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::GlobalId& o,
                         const dueca::GlobalId& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::GlobalId& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::GlobalId& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::GlobalId& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::GlobalId>();
template <>
inline const char* dueca::getclassname<const dueca::GlobalId>()
{ return dueca::getclassname<dueca::GlobalId>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    GlobalId is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::GlobalId> : public dco_isnested { };
};

#endif


