/* ------------------------------------------------------------------ */
/*      item            : LogLevel.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : LogLevel.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Generated from a hard-coded version
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated LogLevel.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>



namespace dueca {
 
/** Defines different possible levels for logging data
    */
struct LogLevel
{
  /** typedef for internal reference */
  typedef LogLevel __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


/** Different log levels
 */
  enum Type {
    /** A lot of information, on regular activities */
    Debug,
    /** Some information, on state changes etc. */
    Info,
    /** Not good, but we can handle it */
    Warning,
    /** Error message, trouble */
    Error,
    /** Not a proper level */
    Invalid
  };

  /** The actual error level */
  Type t;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  LogLevel();

  /** Constructor with arguments */
  LogLevel(
        const Type& t);

  /** copy constructor. */
  LogLevel(const LogLevel& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an LogLevel from amorphous storage. */
  LogLevel(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~LogLevel();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, LogLevel*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the LogLevel into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the LogLevel into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const LogLevel& ref) const;

  /** unpacks the LogLevel from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for LogLevel
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const LogLevel& o) const;

  /** Test for inequality. */
  inline bool operator != (const LogLevel& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  LogLevel& operator=(const LogLevel& o);

  /** prints the LogLevel to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "LogLevelExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::LogLevel& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::LogLevel& o,
                         const dueca::LogLevel& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::LogLevel& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::LogLevel& o)
{ o.unPackDataDiff(s); }
#endif

namespace dueca {
  const char* const getString(const dueca::LogLevel::Type &o);
  void readFromString(dueca::LogLevel::Type &o, const std::string& s);
  void getFirst(dueca::LogLevel::Type &o);
  bool getNext(dueca::LogLevel::Type &o);

  /** This function retrieves the classname of an LogLevel::Type */
  template <>
  const char* getclassname<dueca::LogLevel::Type>();
}; // end namespace dueca

#if !defined(__DCO_NOPACK)
void packData(::dueca::AmorphStore& s,
              const dueca::LogLevel::Type &o);
void unPackData(::dueca::AmorphReStore& s,
                dueca::LogLevel::Type &o);
#endif

PRINT_NS_START;
/** Print an object of type LogLevel::Type */
inline std::ostream&
operator << (std::ostream& s, const dueca::LogLevel::Type& o)
{ return s << dueca::getString(o); }
/** Read an object of type LogLevel::Type */
inline std::istream&
/** Read an enum of type LogLevel::Type */
operator >> (std::istream& s, dueca::LogLevel::Type& o)
{ std::string tmp; s >> tmp; dueca::readFromString(o, tmp); return s; }
PRINT_NS_END;

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::LogLevel& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::LogLevel>();
template <>
inline const char* dueca::getclassname<const dueca::LogLevel>()
{ return dueca::getclassname<dueca::LogLevel>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    LogLevel is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::LogLevel> : public dco_isnested { };
template <>
struct dco_nested<dueca::LogLevel::Type> : public dco_isenum { };
};

#endif


