/* ------------------------------------------------------------------ */
/*      item            : ScriptConfirm.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : ScriptConfirm.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Start-up confirmation message
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ScriptConfirm.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>



namespace dueca {
 
/** Script confirmation, sent when configuration has been fully received
    */
struct ScriptConfirm
{
  /** typedef for internal reference */
  typedef ScriptConfirm __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** confirmation number is updated each confirmation cycle */
  uint16_t confirm_no;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ScriptConfirm();

  /** Constructor with arguments */
  ScriptConfirm(
        const uint16_t& confirm_no);

  /** copy constructor. */
  ScriptConfirm(const ScriptConfirm& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ScriptConfirm from amorphous storage. */
  ScriptConfirm(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ScriptConfirm();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ScriptConfirm*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ScriptConfirm into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ScriptConfirm into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ScriptConfirm& ref) const;

  /** unpacks the ScriptConfirm from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ScriptConfirm
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ScriptConfirm& o) const;

  /** Test for inequality. */
  inline bool operator != (const ScriptConfirm& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ScriptConfirm& operator=(const ScriptConfirm& o);

  /** prints the ScriptConfirm to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ScriptConfirm& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ScriptConfirm& o,
                         const dueca::ScriptConfirm& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ScriptConfirm& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ScriptConfirm& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ScriptConfirm& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ScriptConfirm>();
template <>
inline const char* dueca::getclassname<const dueca::ScriptConfirm>()
{ return dueca::getclassname<dueca::ScriptConfirm>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ScriptConfirm is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ScriptConfirm> : public dco_isnested { };
};

#endif


