/* ------------------------------------------------------------------ */
/*      item            : IncoMode.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : IncoMode.dco
        made by         : Rene' van Paassen
        date            : 230626
        description     : Generated from a hard-coded version
        copyright       : (c) 2023 René van Paassen
        license         : EUPL-1.2
*/

#pragma once

#include <inttypes.h>

#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
};
#endif

#if !defined(__DCO_STANDALONE)
#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated IncoMode.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif

#include <iostream>



namespace dueca {


/** Enumerated type for an automatically generated object class */
enum IncoMode {
    /** specify the flight path+speed, get power, etc. */
    FlightPath,
    /** specify the speed and power, get flight path */
    Speed,
    /** ground inco calculation, gear down, speed 0 */
    Ground,
    /** count, maximum, not a real mode */
    NoIncoModes
};

} 


namespace dueca {
  const char* const getString(const dueca::IncoMode &o);
  void readFromString(dueca::IncoMode &o, const std::string& s);
  void getFirst(dueca::IncoMode &o);
  bool getNext(dueca::IncoMode &o);
}; // end namespace dueca

#if !defined(__DCO_NOPACK)
void packData(::dueca::AmorphStore& s,
              const dueca::IncoMode &o);
void unPackData(::dueca::AmorphReStore& s,
                dueca::IncoMode &o);
#endif

PRINT_NS_START;
/** Print an object of type IncoMode */
inline std::ostream&
operator << (std::ostream& s, const dueca::IncoMode& o)
{ return s << dueca::getString(o); }
/** Read an enum of type IncoMode */
inline std::istream&
operator >> (std::istream& s, dueca::IncoMode& o)
{ std::string tmp; s >> tmp; dueca::readFromString(o, tmp); return s; }
PRINT_NS_END;

/** This function retrieves the classname of IncoMode */
template <>
const char* dueca::getclassname<dueca::IncoMode>();
template <>
inline const char* dueca::getclassname<const dueca::IncoMode>()
{ return dueca::getclassname<dueca::IncoMode>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
template <>
struct dco_nested<dueca::IncoMode> : public dco_isenum { };
};
#endif
