/* ------------------------------------------------------------------ */
/*      item            : IncoNotice.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : IncoNotice.dco
        made by         : Rene' van Paassen
        date            : 1301004
        description     : Generated from a hard-coded version
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated IncoNotice.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <list>
#include "IndexValuePair.hxx"
#include "IncoMode.hxx"

namespace dueca {
 
/** Object to send initial condition data between modules and the trim
    condition calculation machine
    */
struct IncoNotice
{
  /** typedef for internal reference */
  typedef IncoNotice __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** List of index and value pairs */
  std::list<IndexValuePair> ivlist;

  /** Mode that is currently requested */
  IncoMode mode;

  /** Cycle in the communication */
  uint32_t cycle;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  IncoNotice(
        const IncoMode& mode = FlightPath,
        const uint32_t& cycle = 0U);

  /** Constructor with arguments */
  IncoNotice(
        const std::list<IndexValuePair>& ivlist,
        const IncoMode& mode,
        const uint32_t& cycle);

  /** copy constructor. */
  IncoNotice(const IncoNotice& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an IncoNotice from amorphous storage. */
  IncoNotice(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~IncoNotice();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, IncoNotice*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the IncoNotice into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the IncoNotice into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const IncoNotice& ref) const;

  /** unpacks the IncoNotice from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for IncoNotice
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const IncoNotice& o) const;

  /** Test for inequality. */
  inline bool operator != (const IncoNotice& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  IncoNotice& operator=(const IncoNotice& o);

  /** prints the IncoNotice to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "IncoNoticeExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::IncoNotice& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::IncoNotice& o,
                         const dueca::IncoNotice& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::IncoNotice& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::IncoNotice& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::IncoNotice& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::IncoNotice>();
template <>
inline const char* dueca::getclassname<const dueca::IncoNotice>()
{ return dueca::getclassname<dueca::IncoNotice>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    IncoNotice is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::IncoNotice> : public dco_isnested { };
};

#endif


