/* ------------------------------------------------------------------ */
/*      item            : CycleCounter.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        original item   : CycleCounter.dco
        made by         : Rene' van Paassen
        date            : 200612
        description     : Repeating, possibly overflowing counter
                          for message cycles
        copyright       : (c) 2020-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated CycleCounter.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <inttypes.h>

namespace dueca {
 
/** An automatically generated class
    */
struct CycleCounter
{
  /** typedef for internal reference */
  typedef CycleCounter __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** implementation of the counter */
  uint32_t cycle_counter;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  CycleCounter();

  /** Constructor with arguments */
  CycleCounter(
        const uint32_t& cycle_counter);

  /** copy constructor. */
  CycleCounter(const CycleCounter& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an CycleCounter from amorphous storage. */
  CycleCounter(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~CycleCounter();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, CycleCounter*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the CycleCounter into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the CycleCounter into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const CycleCounter& ref) const;

  /** unpacks the CycleCounter from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for CycleCounter
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const CycleCounter& o) const;

  /** Test for inequality. */
  inline bool operator != (const CycleCounter& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  CycleCounter& operator=(const CycleCounter& o);

  /** prints the CycleCounter to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "CycleCounterExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::CycleCounter& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::CycleCounter& o,
                         const dueca::CycleCounter& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::CycleCounter& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::CycleCounter& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::CycleCounter& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::CycleCounter>();
template <>
inline const char* dueca::getclassname<const dueca::CycleCounter>()
{ return dueca::getclassname<dueca::CycleCounter>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    CycleCounter is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::CycleCounter> : public dco_isnested { };
};

#endif


