/* ------------------------------------------------------------------ */
/*      item            : UDPPeerJoined.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        original item   : UDPPeerJoined.dco
        made by         : Rene' van Paassen
        date            : 170205
        documentation   : DUECA_API
        description     : Peer Information udp nodes
        copyright       : (c) 2017-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated UDPPeerJoined.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <stringoptions.h>
#include <inttypes.h>

namespace dueca {
 
/** Notification message on the joining of a peer to a replicator network
    */
struct UDPPeerJoined
{
  /** typedef for internal reference */
  typedef UDPPeerJoined __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** network address of the joining peer */
  vstring netaddress;

  /** proposed peer id -- for matching a possible response */
  uint16_t peer_id;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  UDPPeerJoined();

  /** Constructor with arguments */
  UDPPeerJoined(
        const vstring& netaddress,
        const uint16_t& peer_id);

  /** copy constructor. */
  UDPPeerJoined(const UDPPeerJoined& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an UDPPeerJoined from amorphous storage. */
  UDPPeerJoined(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~UDPPeerJoined();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, UDPPeerJoined*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the UDPPeerJoined into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the UDPPeerJoined into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const UDPPeerJoined& ref) const;

  /** unpacks the UDPPeerJoined from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for UDPPeerJoined
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const UDPPeerJoined& o) const;

  /** Test for inequality. */
  inline bool operator != (const UDPPeerJoined& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  UDPPeerJoined& operator=(const UDPPeerJoined& o);

  /** prints the UDPPeerJoined to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::UDPPeerJoined& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::UDPPeerJoined& o,
                         const dueca::UDPPeerJoined& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::UDPPeerJoined& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::UDPPeerJoined& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::UDPPeerJoined& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::UDPPeerJoined>();
template <>
inline const char* dueca::getclassname<const dueca::UDPPeerJoined>()
{ return dueca::getclassname<dueca::UDPPeerJoined>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    UDPPeerJoined is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::UDPPeerJoined> : public dco_isnested { };
};

#endif


