/* ------------------------------------------------------------------ */
/*      item            : NameSizeDate.hxx
        generated by    : Autobuild (abuild)
        date            : Thu 09 Nov 2023
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        original item   : NameSizeDate.dco
        made by         : Rene' van Paassen
        date            : 200617
        description     : Simple text-based object
        copyright       : (c) 2020-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated NameSizeDate.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <string>
#include <inttypes.h>

#ifdef DUECA_CONFIG_HDF5
#include <H5Cpp.h>
#include <hdf5utils/HDF5DCOMetaFunctor.hxx>
#endif
namespace dueca {
 
/** Details of a file, name, size, date
    */
struct NameSizeDate
{
  /** typedef for internal reference */
  typedef NameSizeDate __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** filename */
  std::string name;

  /** file length */
  uint32_t size;

  /** creation/modification date */
  std::string date;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  NameSizeDate();

  /** Constructor with arguments */
  NameSizeDate(
        const std::string& name,
        const uint32_t& size,
        const std::string& date);

  /** copy constructor. */
  NameSizeDate(const NameSizeDate& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an NameSizeDate from amorphous storage. */
  NameSizeDate(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~NameSizeDate();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, NameSizeDate*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the NameSizeDate into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the NameSizeDate into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const NameSizeDate& ref) const;

  /** unpacks the NameSizeDate from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for NameSizeDate
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const NameSizeDate& o) const;

  /** Test for inequality. */
  inline bool operator != (const NameSizeDate& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  NameSizeDate& operator=(const NameSizeDate& o);

  /** prints the NameSizeDate to a stream. */
  std::ostream & print(std::ostream& s) const;

#ifdef DUECA_CONFIG_HDF5
  /** create a HDF5 datatype */
  static const H5::DataType* getHDF5DataType();
#endif
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::NameSizeDate& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::NameSizeDate& o,
                         const dueca::NameSizeDate& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::NameSizeDate& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::NameSizeDate& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::NameSizeDate& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::NameSizeDate>();
template <>
inline const char* dueca::getclassname<const dueca::NameSizeDate>()
{ return dueca::getclassname<dueca::NameSizeDate>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    NameSizeDate is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::NameSizeDate> : public dco_isnested { };
};

#endif

#if defined(DUECA_CONFIG_HDF5)
// functors guarded in a separate namespace
namespace NameSizeDate_space {

  // writes to file, reading from channel
  class HDF5DCOWriteFunctor: public dueca::hdf5log::HDF5DCOWriteFunctor
  {
    NameSizeDate example;
  public:
    // constructor, to be invoked by the metafunctor
    HDF5DCOWriteFunctor(std::weak_ptr<H5::H5File> file,
                        const std::string& path,
                        size_t chunksize,
                        const std::string& label,
                        bool compress, bool writeticks,
                        const dueca::DataTimeSpec* startend);

    // the functor member used by channel reading code
    bool operator() (const void* dpointer, const dueca::DataTimeSpec& ts);
  };

  // reads from file, writing to channel
  class HDF5DCOReadFunctor: public dueca::hdf5log::HDF5DCOReadFunctor
  {
    NameSizeDate example;
  public:
    // constructor, to be invoked by the metafunctor
    HDF5DCOReadFunctor(std::weak_ptr<H5::H5File> file,
                       const std::string& path,
                       bool readticks);
    // the functor member used by channel writing code
    bool operator() (void* dpointer);
  };
} // end namespace NameSizeDate_space
#endif


